<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\GLocaisService;

use FM\Traits\TResponse;


class GLocaisController extends FMCrud{
    use TResponse;
    protected $GLocaisService;
   
    public function __construct($crudService, $environment, GLocaisService $GLocaisService) {
        parent::__construct($crudService, $environment);
        $this->GLocaisService = $GLocaisService;
    }

    public function getControllerUnities(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();
        
        $var = $this->GLocaisService->getServiceUnities($params);
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
        
        // try {
        //     $data =  $this->GLocaisService->getServiceUnities($request->getParameters());
        //     $this->sendResponse($data, 200);
        // } catch (Exception $ex) {
        //     $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        // }
    }
    
    public function getControllerLocal(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();
        
        $nrlocalclientepai = $params['params']['NRLOCALCLIENTEPAI'];
        $var = $this->GLocaisService->getServiceLocal($nrlocalclientepai);
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerLocalType(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();
        
        $var = $this->GLocaisService->getServiceLocalType($params);
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    // Deleta um local e seus filhos
    public function deleteLocation(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $var = $this->GLocaisService->deleteLocation($params);

        $dtsVal = new DataSet('info', array('message' => $var));
        $response->addDataSet($dtsVal);
    }
}
?>