<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\LocalService;

class LocalController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $LocalService;
   
    public function __construct($crudService, $environment, LocalService $LocalService) {
        parent::__construct($crudService, $environment);
        $this->LocalService = $LocalService;
    }
    
    public function getAllLocals(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $var = $this->LocalService->getAllLocals($params);
        $dtsVal = new DataSet('Locals', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getLocals(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $var = $this->LocalService->getLocals($params);
        $dtsVal = new DataSet('Locals', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function Locals(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('Locals', $this->LocalService->Locals()));
    }
}
?>