/*
-- ==================================================================== --
-- SISTEMA         : GESTAO DE VENDAS                                   --
-- DATA DA CRIAO : 09/07/2012                                         --
-- CRIAO         : LEONARDO MATOS                                     --
-- OBJETIVOS       : GRAVA CREDITOS NA EXTRATOCONS VINDAS DO PORTAL SDX --
-- ==================================================================== --
*/
CREATE OR REPLACE TRIGGER CARGA_CRED_PORTAL_SDX
BEFORE INSERT OR DELETE OR UPDATE
ON CREDITOPORTALSDX FOR EACH ROW
DECLARE
   V_CDCLIENTE         VARCHAR2(21);
   V_CDCONSUMIDOR      VARCHAR2(21);
   V_CDFAMILISALD      VARCHAR2(3);
   V_INSERE            VARCHAR2(1);
   P_PRXEXTRATOCONSVND VARCHAR2(20);
BEGIN
   /* VARIAVEL CONTROLA SE IR INSERIR DADOS OU NO NA EXTRATOCONS */
   
   V_INSERE := 'S'; 

   /* VERIFICAO SE ESTA INSERINDO */
   /* SO REALIZA INSERCAO NA EXTRATOCONS SE FOR INSERIDO DADOS NA CREDITOPORTALSDX , EDITANDO E EXCLUINDO NO FAZ NADA NA TRIGGER */

   IF INSERTING THEN

      /* VALIDAO DO CLIENTE */

      IF V_INSERE = 'S' THEN
          IF NVL(:NEW.CDCLIENTE,'0') <> '0' THEN

             BEGIN
                SELECT CDCLIENTE
                INTO   V_CDCLIENTE
                FROM   CLIENTE
                WHERE  CDCLIENTE = :NEW.CDCLIENTE;
                EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDCLIENTE    := NULL;
             END;

             IF V_CDCLIENTE IS NULL THEN
                :NEW.DSMOTIVONAOINC := 'CLIENTE NO CADASTRADO';
                :NEW.DTATUALIZACAO := SYSDATE;
                :NEW.IDSIT := 'N';
                V_INSERE := 'N';
             END IF;

          ELSE
             :NEW.DSMOTIVONAOINC := 'CLIENTE NO INFORMADO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF ;

      /* VALIDAO DO CONSUMIDOR */

      IF V_INSERE  = 'S' THEN

          IF NVL(:NEW.CDCONSUMIDOR,'0') <> '0' THEN

             BEGIN
                SELECT CDCONSUMIDOR
                INTO   V_CDCONSUMIDOR
                FROM   CONSUMIDOR
                WHERE  CDCLIENTE = :NEW.CDCLIENTE
                  AND CDCONSUMIDOR = :NEW.CDCONSUMIDOR;
                EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDCONSUMIDOR    := NULL;
             END;

             IF V_CDCONSUMIDOR IS NULL THEN
                :NEW.DSMOTIVONAOINC := 'CONSUMIDOR NO CADASTRADO';
                :NEW.DTATUALIZACAO := SYSDATE;
                :NEW.IDSIT := 'N';
                V_INSERE := 'N';
             END IF;

          ELSE

             :NEW.DSMOTIVONAOINC := 'CONSUMIDOR NO INFORMADO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;

      /* VALIDAO DA FAMILIA DE PRODUTO */

      IF V_INSERE = 'S' THEN

          IF NVL(:NEW.CDFAMILISALD,'0') <> '0' THEN
             BEGIN
                SELECT CDFAMILISALD
                INTO   V_CDFAMILISALD
                FROM   FAMILIASALDO
                WHERE  CDFAMILISALD = :NEW.CDFAMILISALD;
                EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDFAMILISALD := NULL;
             END;

             IF V_CDFAMILISALD IS NULL THEN
                :NEW.DSMOTIVONAOINC := 'FAMLIA NO CADASTRADA';
                :NEW.DTATUALIZACAO := SYSDATE;
                :NEW.IDSIT := 'N';
                V_INSERE := 'N';
             END IF;

          ELSE
             :NEW.DSMOTIVONAOINC := 'FAMLIA NO INFORMADA';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;


      /* VALIDAO REFERENTE A DATA CREDITO */

      IF V_INSERE = 'S' THEN

          IF NVL(:NEW.DTCREDITO,TO_DATE('01/01/0001','DD/MM/YYYY')) = TO_DATE('01/01/0001','DD/MM/YYYY') THEN

             :NEW.DSMOTIVONAOINC := 'DATA DE CRDITO NO INFORMADA';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;

      /* VALIDAO DO VALOR DO CREDITO */

      IF V_INSERE = 'S' THEN

          IF NVL(:NEW.VRCREDITO,99999) = 99999 THEN
             :NEW.DSMOTIVONAOINC := 'VALOR DE CRDITO NO INFORMADO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;

          IF NVL(:NEW.VRCREDITO,99999) <= 0 THEN
             :NEW.DSMOTIVONAOINC := 'VALOR DE CRDITO DEVE SER MAIOR QUE ZERO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;

      /* VALIDAO DO NR. BOLETO OU NR. DE CARTO*/

      IF V_INSERE = 'S' THEN

          IF NVL(:NEW.DSOBSERVACAO,'0') = '0' THEN
             :NEW.DSMOTIVONAOINC := 'BOLETO/CARTO CRED. NO INFORMADO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;

     /* VALIDAO DO IDENTIFICADOR */

      IF V_INSERE = 'S' THEN

          IF NVL(:NEW.IDSIT,'0') <> '0' THEN
             IF :NEW.IDSIT <> 'I' THEN
                :NEW.DSMOTIVONAOINC := 'IDENTIFICADOR INEXISTENTE';
                :NEW.DTATUALIZACAO := SYSDATE;
                :NEW.IDSIT := 'N';
                V_INSERE := 'N';
             END IF;
          ELSE
             :NEW.DSMOTIVONAOINC := 'IDENTIFICADOR NO INFORMADO';
             :NEW.DTATUALIZACAO := SYSDATE;
             :NEW.IDSIT := 'N';
              V_INSERE := 'N';
          END IF;
      END IF;

      /* ACIONA INSERO NA EXTRATOCONS */

      IF V_INSERE = 'S'     THEN

          /* PROXIMO CODIGO SEM COMMIT DO CREDITO PARA INSERIR DADOS NA EXTRATOCONS - PROXIMO CODIGO SOMENTE PARA CREDITOS NO VND */

         NOVO_CODIGO_SC('EXTRATOCONSVND',P_PRXEXTRATOCONSVND);

         /* INSERE O CREDITO NA TABELA EXTRATOCONS*/

         INSERT INTO EXTRATOCONS
            (CDCLIENTE   , CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT,
             CDTIPORECE  , DSOPEEXTCONS, 
             VRMOVEXTCONS, VRSALDCONEXT, IDTPMOVEXT, IDIMPEXTCONS, 
             DTULTATUEXT,  IDCANZERASALD, NRDEPOSICONS, NRSEQREGCREDVND )
         VALUES
            (:NEW.CDCLIENTE, :NEW.CDCONSUMIDOR, :NEW.CDFAMILISALD, :NEW.DTCREDITO,'001',
             '001',SUBSTR('Credito Via Portal '||:NEW.DSOBSERVACAO,1,30) ,
             :NEW.VRCREDITO, :NEW.VRCREDITO, 'C', 'N',
             SYSDATE, 'N', SUBSTR(:NEW.DSOBSERVACAO,1,20) , P_PRXEXTRATOCONSVND  ) ;

	   /* ACIONA PROCEDURE PARA RECALCULAR DE SALDO DO CONSUMIDOR, ATUALIZA EXTRATOCONS E SALDOCONS (90 dias) */

         ATUALIZA_SALDO_CONS_FKB(:NEW.CDCLIENTE, :NEW.CDCONSUMIDOR, :NEW.CDFAMILISALD, :NEW.DTCREDITO - 90);
                           
         /* ATUALIZA DATA DE ATUALIZAO E SITUAO */

         :NEW.DTATUALIZACAO := SYSDATE;
         :NEW.IDSIT := 'A';

      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CARGA_CRED_PORTAL_SDX','5.21.000'); END;
/
